--- old/usr/src/cmd/localedef/ctype.c	2012-09-10 00:05:32.364292228 +0000
+++ new/usr/src/cmd/localedef/ctype.c	2012-09-10 00:05:32.421174103 +0000
@@ -211,6 +211,7 @@
 	_FileRuneEntry	*ct = NULL;
 	_FileRuneEntry	*lo = NULL;
 	_FileRuneEntry	*up = NULL;
+	wchar_t		wc;
 
 	(void) memset(&rl, 0, sizeof (rl));
 	last_ct = NULL;
@@ -223,11 +224,19 @@
 	(void) memcpy(rl.magic, _FILE_RUNE_MAGIC_1, 8);
 	(void) strncpy(rl.encoding, get_wide_encoding(), sizeof (rl.encoding));
 
-	for (ctn = avl_first(&ctypes); ctn; ctn = AVL_NEXT(&ctypes, ctn)) {
+	/*
+	 * Initialize the identity map.
+	 */
+	for (wc = 0; (unsigned)wc < _CACHED_RUNES; wc++) {
+		rl.maplower[wc] = wc;
+		rl.mapupper[wc] = wc;
+	}
 
-		wchar_t	wc = ctn->wc;
+	for (ctn = avl_first(&ctypes); ctn; ctn = AVL_NEXT(&ctypes, ctn)) {
 		int conflict = 0;
 
+		wc = ctn->wc;
+
 		/*
 		 * POSIX requires certain portable characters have
 		 * certain types.  Add them if they are missing.
@@ -305,8 +314,10 @@
 		 */
 		if ((unsigned)wc < _CACHED_RUNES) {
 			rl.runetype[wc] = ctn->ctype;
-			rl.maplower[wc] = ctn->tolower ? ctn->tolower : wc;
-			rl.mapupper[wc] = ctn->toupper ? ctn->toupper : wc;
+			if (ctn->tolower)
+				rl.maplower[wc] = ctn->tolower;
+			if (ctn->toupper)
+				rl.mapupper[wc] = ctn->toupper;
 			continue;
 		}
 
